
var Timer = {
	config: {
		update: function() {
			var prefs = Components.classes["@mozilla.org/preferences;1"]
				.createInstance(Components.interfaces.nsIPrefBranch);
			this.time = prefs.getIntPref("extensions.timer.time");
			this.startmusic = prefs.getBoolPref("extensions.timer.startmusic");
		}
	},
	onMenuCommand: function() {
		window.openDialog("chrome://timer/content/options.xul","TimerPrefsDialog","chrome,centerscreen,dialog,modal");
		Timer.config.update();
		Timer.startTimer();
	},
	startTimer: function() {
		var timerID = null;
		return function() {
			if (timerID) {
				self.clearTimeout(timerID);
			}
			var callback = function(startmusic) {
				return function() {
					try {
						var gMM = Components.classes["@songbirdnest.com/Songbird/Mediacore/Manager;1"]
							.getService(Components.interfaces.sbIMediacoreManager);
						if (startmusic) {
							gMM.playbackControl.play();
						} else {
							gMM.playbackControl.pause();
						}
					} catch (e) {
					} finally {
						timerID = null;
					}
				};
			}(Timer.config.startmusic);
			timerID = self.setTimeout(callback, Timer.config.time * 60000);
		};
	}()
};
